// https://lunrjs.com/guides/index_prebuilding.html
const lunr = require('lunr'),
      stdin = process.stdin,
      stdout = process.stdout,
      lang = process.argv[2]

var buffer = []

// Load Lunr languages
require("lunr-languages/lunr.stemmer.support")(lunr)
require(`lunr-languages/lunr.${lang}`)(lunr)
require("lunr-languages/lunr.multi")(lunr)

stdin.resume()
stdin.setEncoding('utf8')

stdin.on('data', (data) => buffer.push(data))

stdin.on('end', () => {
  const docs = JSON.parse(buffer.join(''))
  const fields = [].concat.apply([], docs.map((doc) => Object.keys(doc)))
    .filter((item, pos, self) => self.indexOf(item) == pos)

  // We keep this syntax because we don't know enough JS to make `this`
  // work with ES16 or whatever it's called
  var idx = lunr(function() {
    this.use(lunr.multiLanguage(lang, 'en'))
    fields.forEach((f) => this.field(f))
    docs.forEach((doc) => this.add(doc))
  })

  stdout.write(JSON.stringify(idx))
})
